'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var generateConnectionString = function () {
  var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(port, dbName) {
    var db;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.t0 = dbName;

            if (_context.t0) {
              _context.next = 5;
              break;
            }

            _context.next = 4;
            return (0, _v2.default)();

          case 4:
            _context.t0 = _context.sent;

          case 5:
            db = _context.t0;
            return _context.abrupt('return', `mongodb://localhost:${port}/${db}`);

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function generateConnectionString(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

var _mongodbPrebuilt = require('mongodb-prebuilt');

var _v = require('uuid/v4');

var _v2 = _interopRequireDefault(_v);

var _tmp = require('tmp');

var _tmp2 = _interopRequireDefault(_tmp);

var _getPort = require('get-port');

var _getPort2 = _interopRequireDefault(_getPort);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

_tmp2.default.setGracefulCleanup();

var MongoDBMemoryServer = function () {
  function MongoDBMemoryServer() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, MongoDBMemoryServer);

    this.isRunning = false;

    this.opts = opts;

    // autoStart by default
    if (!opts.hasOwnProperty('autoStart') || opts.autoStart) {
      if (opts.debug) {
        console.log('Autostarting MongoDB instance...');
      }
      this.start();
    }
  }

  _createClass(MongoDBMemoryServer, [{
    key: 'debug',
    value: function debug(msg) {
      if (this.opts.debug) {
        console.log(msg);
      }
    }
  }, {
    key: 'start',
    value: function () {
      var _ref2 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
        var _this = this;

        return regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                if (!this.runningInstance) {
                  _context2.next = 2;
                  break;
                }

                throw new Error('MongoDB instance already in status startup/running/error. Use opts.debug = true for more info.');

              case 2:

                this.runningInstance = this._startUpInstance().catch(function (err) {
                  if (err.message === 'Mongod shutting down' || err === 'Mongod shutting down') {
                    _this.debug(`Mongodb does not started. Trying to start on another port one more time...`);
                    _this.opts.port = null;
                    return _this._startUpInstance();
                  }
                  throw err;
                }).catch(function (err) {
                  if (!_this.opts.debug) {
                    throw new Error(`${err.message}\n\nUse debug option for more info: new MongoMemoryServer({ debug: true })`);
                  }
                  throw err;
                });

                return _context2.abrupt('return', this.runningInstance.then(function () {
                  return true;
                }));

              case 4:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function start() {
        return _ref2.apply(this, arguments);
      }

      return start;
    }()
  }, {
    key: '_startUpInstance',
    value: function () {
      var _ref3 = _asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
        var data, tmpDir, mongodCli;
        return regeneratorRuntime.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                data = {};
                tmpDir = void 0;
                _context3.next = 4;
                return (0, _getPort2.default)(this.opts.port);

              case 4:
                data.port = _context3.sent;
                _context3.next = 7;
                return generateConnectionString(data.port);

              case 7:
                data.uri = _context3.sent;

                data.storageEngine = this.opts.storageEngine || 'ephemeralForTest';
                if (this.opts.dbPath) {
                  data.dbPath = this.opts.dbPath;
                } else {
                  tmpDir = _tmp2.default.dirSync({ prefix: 'mongo-mem-', unsafeCleanup: true });
                  data.dbPath = tmpDir.name;
                }

                this.debug(`Starting MongoDB instance with following options: ${JSON.stringify(data)}`);

                mongodCli = new _mongodbPrebuilt.MongodHelper(['--port', data.port, '--storageEngine', data.storageEngine, '--dbpath', data.dbPath, '--noauth']);


                mongodCli.debug.enabled = this.opts.debug;

                // Download if not exists mongo binaries in ~/.mongodb-prebuilt
                // After that startup MongoDB instance
                _context3.next = 15;
                return mongodCli.run();

              case 15:

                data.mongodCli = mongodCli;
                data.tmpDir = tmpDir;

                return _context3.abrupt('return', data);

              case 18:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _startUpInstance() {
        return _ref3.apply(this, arguments);
      }

      return _startUpInstance;
    }()
  }, {
    key: 'stop',
    value: function () {
      var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee4() {
        var _ref5, mongodCli, port, tmpDir;

        return regeneratorRuntime.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _context4.next = 2;
                return this.getInstanceData();

              case 2:
                _ref5 = _context4.sent;
                mongodCli = _ref5.mongodCli;
                port = _ref5.port;
                tmpDir = _ref5.tmpDir;


                if (mongodCli && mongodCli.mongoBin.childProcess) {
                  // .mongoBin.childProcess.connected
                  this.debug(`Shutdown MongoDB server on port ${port} with pid ${mongodCli.mongoBin.childProcess.pid}`);
                  mongodCli.mongoBin.childProcess.kill();
                }

                if (tmpDir) {
                  this.debug(`Removing tmpDir ${tmpDir.name}`);
                  tmpDir.removeCallback();
                }

                this.runningInstance = null;
                return _context4.abrupt('return', true);

              case 10:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function stop() {
        return _ref4.apply(this, arguments);
      }

      return stop;
    }()
  }, {
    key: 'getInstanceData',
    value: function () {
      var _ref6 = _asyncToGenerator(regeneratorRuntime.mark(function _callee5() {
        return regeneratorRuntime.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                if (!this.runningInstance) {
                  _context5.next = 2;
                  break;
                }

                return _context5.abrupt('return', this.runningInstance);

              case 2:
                throw new Error('Database instance is not running. You should start database by calling start() method. BTW it should start automatically if opts.autoStart!=false. Also you may provide opts.debug=true for more info.');

              case 3:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function getInstanceData() {
        return _ref6.apply(this, arguments);
      }

      return getInstanceData;
    }()
  }, {
    key: 'getUri',
    value: function () {
      var _ref7 = _asyncToGenerator(regeneratorRuntime.mark(function _callee6() {
        var otherDbName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

        var _ref8, uri, port;

        return regeneratorRuntime.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return this.getInstanceData();

              case 2:
                _ref8 = _context6.sent;
                uri = _ref8.uri;
                port = _ref8.port;

                if (!otherDbName) {
                  _context6.next = 9;
                  break;
                }

                if (!(typeof otherDbName === 'string')) {
                  _context6.next = 8;
                  break;
                }

                return _context6.abrupt('return', generateConnectionString(port, otherDbName));

              case 8:
                return _context6.abrupt('return', generateConnectionString(port));

              case 9:
                return _context6.abrupt('return', uri);

              case 10:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function getUri() {
        return _ref7.apply(this, arguments);
      }

      return getUri;
    }()
  }, {
    key: 'getConnectionString',
    value: function () {
      var _ref9 = _asyncToGenerator(regeneratorRuntime.mark(function _callee7() {
        var otherDbName = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;
        return regeneratorRuntime.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                return _context7.abrupt('return', this.getUri(otherDbName));

              case 1:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function getConnectionString() {
        return _ref9.apply(this, arguments);
      }

      return getConnectionString;
    }()
  }, {
    key: 'getPort',
    value: function () {
      var _ref10 = _asyncToGenerator(regeneratorRuntime.mark(function _callee8() {
        var _ref11, port;

        return regeneratorRuntime.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _context8.next = 2;
                return this.getInstanceData();

              case 2:
                _ref11 = _context8.sent;
                port = _ref11.port;
                return _context8.abrupt('return', port);

              case 5:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function getPort() {
        return _ref10.apply(this, arguments);
      }

      return getPort;
    }()
  }, {
    key: 'getDbPath',
    value: function () {
      var _ref12 = _asyncToGenerator(regeneratorRuntime.mark(function _callee9() {
        var _ref13, dbPath;

        return regeneratorRuntime.wrap(function _callee9$(_context9) {
          while (1) {
            switch (_context9.prev = _context9.next) {
              case 0:
                _context9.next = 2;
                return this.getInstanceData();

              case 2:
                _ref13 = _context9.sent;
                dbPath = _ref13.dbPath;
                return _context9.abrupt('return', dbPath);

              case 5:
              case 'end':
                return _context9.stop();
            }
          }
        }, _callee9, this);
      }));

      function getDbPath() {
        return _ref12.apply(this, arguments);
      }

      return getDbPath;
    }()
  }]);

  return MongoDBMemoryServer;
}();

exports.default = MongoDBMemoryServer;